/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

/* Generated By:JJTree: Do not edit this line. SimpleNode.java */

package ZEN_IDL.ast;

public class SimpleNode implements Node {
  protected Node parent;
  protected Node[] children;
  protected int id;
  protected IDLParser parser;

  private Token mFirstToken;
  private Token mLastToken;

  public SimpleNode(int i) {
    id = i;
  }

  public SimpleNode(IDLParser p, int i) {
    this(i);
    parser = p;
  }

  public void jjtOpen() {
    mFirstToken = parser.getToken(1);
  }

  public void jjtClose() {
    mLastToken = parser.getToken(0);
  }
 
  public Token getFirstToken() {
    return mFirstToken;
  }
  
  public Token getLastToken() {
    return mLastToken;
  }

  public void jjtSetParent(Node n) { parent = n; }
  public Node jjtGetParent() { return parent; }

  public void jjtAddChild(Node n, int i) {
    if (children == null) {
      children = new Node[i + 1];
    } else if (i >= children.length) {
      Node c[] = new Node[i + 1];
      System.arraycopy(children, 0, c, 0, children.length);
      children = c;
    }
    children[i] = n;
  }

  public Node jjtGetChild(int i) {
    return children[i];
  }

  public int jjtGetNumChildren() {
    return (children == null) ? 0 : children.length;
  }

  /** Accept the visitor. **/
  public Object jjtAccept(IDLParserVisitor visitor, Object data) {
    return visitor.visit(this, data);
  }

  /** Accept the visitor. **/
  public Object childrenAccept(IDLParserVisitor visitor, Object data) {
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        children[i].jjtAccept(visitor, data);
      }
    }
    return data;
  }

  //Added 10-28-00 David Welker
  /** Get info for XVisitor **/
  public String xGetString()
  {
      //In general, there are two default cases. Either this is a leaf node, in which case
      //numChildren will be zero. Just print the first token in this case. Otherwise, just 
      //print return xGetString() for all children. Other cases require specific overloading.
      //NOTE: The second case does NOT print spaces between the recursive calls.
      if( jjtGetNumChildren() == 0 )
  	return getFirstToken().toString();
     else
      {
         String result = "";
	 int numChildren = jjtGetNumChildren();
	 for( int i = 0; i < numChildren; i++ )
	     result += jjtGetChild(i).xGetString();
         return result;
      }
  }
  /* You can override these two methods in subclasses of SimpleNode to
     customize the way the node appears when the tree is dumped.  If
     your output uses more than one line you should override
     toString(String), otherwise overriding toString() is probably all
     you need to do. */

  public String toString() { return IDLParserTreeConstants.jjtNodeName[id]; }
  public String toString(String prefix) { return prefix + toString(); }

  /* Override this method if you want to customize how the node dumps
     out its children. */

  public void dump(String prefix) {
    System.out.println(toString(prefix));
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
	SimpleNode n = (SimpleNode)children[i];
	if (n != null) {
	  n.dump(prefix + " ");
	}
      }
    }
  }
}

