/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package ZEN_IDL.be.symbolTableUtils;

import java.util.*;
import ZEN_IDL.ast.*;
import ZEN_IDL.be.helperUtils.*;

public class Symbol{
	private String name;
	private String pkg;		//package
	private int IDLType;
	private String safeName;
	private Token thisToken;

	//for interfaces
	private InterfaceInheritence inheritence;
	private Vector interfaceMethods;
	private boolean isAbstract;
	public boolean isInterface;
	
	public Symbol( String name , String pkg , int IDLType , Token thisToken , InterfaceInheritence inheritence, Vector methods , boolean isAbstract ){
		this( name , pkg , IDLType , thisToken );
		this.inheritence = inheritence;
		this.interfaceMethods = methods;
		this.isAbstract = isAbstract;
		isInterface = true;
	}
	public Symbol( String name , String pkg , int IDLType , Token thisToken )
	{
		this.name = name;
		this.pkg = pkg;
		this.IDLType = IDLType;
		this.thisToken = thisToken;
	}
	
	public InterfaceInheritence getInheritenceSpec(){ return inheritence; }
	public Vector getMethods(){ return interfaceMethods; }
	public boolean getIsAbstract(){ return isAbstract; }
	public String getName(){ return name; }
	public String getPackage(){ return pkg; }
	public int getType(){ return IDLType; }
	public void setSafeName( String safeName ){ this.safeName = safeName; }
	public String getSafeName() { return safeName; }
	public String getLocation() { return  "Line: " + thisToken.beginLine + 
		"\tCol: " + thisToken.beginColumn + " "; }	//for error reporting

	public String toString(){
		return "Name:" + name + "\tPackage:" + pkg + "\tType:" + IDLType;
	}
}
