/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

/*********************************************************
* HelloClient class
*---
* Simple test program that sends the string "Hello World" to a server.
*---
* @author David McKinnon
*********************************************************/

import java.net.*;
import java.io.*;

public class HelloClient199 {

    public static void main(String[] args) {
        Socket socket;
        DataInputStream  sInput;
        DataOutputStream sOutput;

        String hostStr = System.getProperty("host");
        if (hostStr == null) {
            if (args.length > 0) {
                hostStr = args[0];
            }
            else {
                hostStr = "199.237.73.213";
            }
        }

        try {
            socket  = new Socket(hostStr, 12721);
            sInput  = new DataInputStream(socket.getInputStream());
            sOutput = new DataOutputStream(socket.getOutputStream());

            sOutput.writeUTF("Hello");

            String str = sInput.readUTF();
            System.out.println(str);
        }
        catch (Exception e) {
            System.out.println(e);
        }
    }
}
