/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package mqc.ior;

/**
* The MQCIOP profile class.
*
* @author Eivind Naess
*/
public class MQCIOPProfile extends TaggedProfile
{

   /**
    * Constructor for the MQCIOP profile
	*/
   public MQCIOPProfile()
   {
      super(TaggedProfile.MQCIOP);
   }

   /**
    * Encodes a corbaloc String from MQCIOP
	* 
	* @param corbalocStr The String buffer to return
	* @return An encoded corbaloc string from MQCIOP
	*/
   public String encodeCorbalocProfile(String corbalocStr)
   {
      corbalocStr = super.encodeCorbalocProfile ("mqciop");
      return corbalocStr;
   }

   /**
    * Overides Clone in Object
	* @return A copy of itself
	*/ 
   public Object clone ()
   {
      MQCIOPProfile profile = new MQCIOPProfile();
      profile.objectKey = new byte[objectKey.length];
      System.arraycopy(objectKey, 0, profile.objectKey, 0, objectKey.length);
      profile.seqLen = seqLen;
      profile.major = major;
      profile.minor = minor;
      profile.host = host;
      profile.port = port;
      profile.bigEndian = bigEndian;
      return profile;
   }
}

